package com.huiju.estateagents.controller;


import com.huiju.estateagents.base.ResponseBean;
import com.huiju.estateagents.entity.TaBuilding;
import com.huiju.estateagents.service.ITaBuildingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.huiju.estateagents.base.BaseController;

import javax.servlet.http.HttpSession;

/**
 * <p>
 * 项目表 前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-05-10
 */
@RestController
@RequestMapping("/api")
public class TaBuildingController extends BaseController {

    @Autowired
    ITaBuildingService taBuildingService;

    /**
     * 楼盘详情
     * @param id
     * @return
     */
    @GetMapping("/admin/buildingSelectId/{id}")
    public ResponseBean buildingSelectId(@PathVariable(value = "id") String id){
        return taBuildingService.buildingSelectId(id);
    }

    /**
     * 楼盘列表
     * @param pageNum
     * @param pageSize
     * @param name
     * @param code
     * @return
     */
    @GetMapping("/admin/buildinglist")
    public ResponseBean buildingList(@RequestParam("pageNum")Integer pageNum,
                                     @RequestParam("pageSize")Integer pageSize,
                                     @RequestParam(value = "name", required = false)String name,
                                     @RequestParam(value = "code", required = false)String code){
        return taBuildingService.buildingList(pageNum,pageSize,name,code);
    }

    /**
     * 更新楼盘
     * @param parameter
     * @return
     */
    @PutMapping("/admin/building/update")
    public ResponseBean buildingUpdate(@RequestBody String parameter){
        return taBuildingService.buildingUpdate(parameter);
    }

    /**
     * 楼盘添加
     * @param parameter
     * @return
     */
    @RequestMapping(value = "/admin/building/add", method = RequestMethod.POST)
    public ResponseBean buildingAdd(@RequestBody String parameter){
        return taBuildingService.buildingAdd(parameter);
    }

    /**
     * 楼盘发布
     * @param parameter
     * @return
     */
    @RequestMapping(value = "/admin/building/update/status", method = RequestMethod.PUT)
    public ResponseBean buildingUpdateStatus(@RequestBody String parameter){
        return taBuildingService.buildingUpdateStatus(parameter);
    }

    /**
     * 楼盘删除
     * @param id
     * @param session
     * @return
     */
    @RequestMapping(value = "/admin/building/delete/{id}", method = RequestMethod.DELETE)
    public ResponseBean buildingdelete(@PathVariable("id") String id, HttpSession session){
        return taBuildingService.buildingdelete(id);
    }

    /**
     * 添加户型
     * @param parameter
     * @param session
     * @return
     */
    @RequestMapping(value = "/admin/buildingApartment/add", method = RequestMethod.POST)
    public ResponseBean buildingApartment(@RequestBody String parameter, HttpSession session){
        return taBuildingService.buildingApartmentAdd(parameter);
    }

    /**
     * 户型编辑
     * @param parameter
     * @return
     */
    @RequestMapping(value = "/admin/buildingApartment/update", method = RequestMethod.PUT)
    public ResponseBean buildingApartmentUpdate(@RequestBody String parameter){
        return taBuildingService.buildingApartmentUpdate(parameter);
    }

    /**
     * 楼盘详情
     * @param id
     * @return
     */
    @RequestMapping(value = "/admin/buildingApartment/{id}", method = RequestMethod.GET)
    public ResponseBean buildingApartmentSelectId(@PathVariable(value = "id") String id){
        return taBuildingService.buildingApartmentSelectId(id);
    }

    /**
     * 依据项目ID 查户型
     * @param id
     * @return
     */
    @RequestMapping(value = "/admin/buildingApartment/buildingId/{id}", method = RequestMethod.GET)
    public ResponseBean buildingApartmentBuildingId(@PathVariable(value = "id") String id){
        return taBuildingService.buildingApartmentBuildingId(id);
    }

    /**
     * 微信楼盘列表
     * @return
     */
    @RequestMapping(value = "/wx/building/list", method = RequestMethod.GET)
    public ResponseBean getWxBuildingList(
            @RequestParam(defaultValue = "1") Integer pageNum,
            @RequestParam(defaultValue = "10")Integer pageSize,
            String name
    ){
        return taBuildingService.getWxBuildingList(pageNum, pageSize, name);
    }

    /**
     * 微信推荐楼盘列表
     * @return
     */
    @RequestMapping(value = "/wx/building/mian", method = RequestMethod.GET)
    public ResponseBean getWxMainBuildingList(){
        return taBuildingService.getWxMainBuildingList();
    }

    /**
     * 删除户型
     * @param id
     * @return
     */
    @RequestMapping(value = "/admin/apartment/deleted/{id}", method = RequestMethod.DELETE)
    public ResponseBean apartmentDeleted(@PathVariable(value = "id") String id){
        return taBuildingService.apartmentDel(id);
    }

    /**
     * 微信楼盘详情
     * @param id
     * @return
     */
    @RequestMapping(value = "/wx/buildingSelectId/{id}", method = RequestMethod.GET)
    public ResponseBean wxBuildingSelectId(@PathVariable(value = "id") String id){
        return taBuildingService.buildingAllSelectId(id);
    }
    /**
     * 查询当前所有项目
     */
    @RequestMapping(value = "/admin/buildingAll", method = RequestMethod.GET)
    public  ResponseBean buildingAll(){
        ResponseBean taBuilding= taBuildingService.buildingAll();
        return taBuilding;
    }
}
